﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Events;
using Infragistics.Windows.Controls;
using System.Collections.ObjectModel;

namespace XamDataGridGroupByDescription
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            
            
        }

        private void xamDataGrid1_Grouped(object sender, GroupedEventArgs e)
        {
            IterateRecords((sender as XamDataGrid).Records);            
        }

        public void IterateRecords(RecordCollectionBase records)
        {
            foreach (Record rec in records)
            {
                if (rec.RecordType == RecordType.GroupByField || rec.RecordType == RecordType.GroupByFieldLayout)
                {
                    GroupByRecord groupRecord = (GroupByRecord)rec;
                    if (!groupRecord.Description.Contains(groupRecord.GroupByField.Name))
                    {
                        groupRecord.Description = groupRecord.GroupByField.Name + " = " + groupRecord.Description;
                    }                    

                    if (groupRecord.HasChildren)                 
                        IterateRecords(groupRecord.ChildRecords);
                }
            }
        }

        private void GroupByRecordPresenter_Loaded(object sender, RoutedEventArgs e)
        {
            GroupByRecord groupRecord = (GroupByRecord)(sender as GroupByRecordPresenter).Record;
            if (!groupRecord.Description.Contains(groupRecord.GroupByField.Name))
            {
                groupRecord.Description = groupRecord.GroupByField.Name + " = " + groupRecord.Description;
            }                    
        }        
    }
}
